package org.ids_mannheim;

import java.util.LinkedList;
import java.util.function.Consumer;

public class SlidingWindowQueue extends LinkedList {
    private final int maxSize;
    private final Consumer<String> flush;

    public SlidingWindowQueue(int size, Consumer<String> flush) {
        this.maxSize = size;
        this.flush = flush;
    }

    public boolean add(String k) {
        boolean r = super.add(k);
        if (size() == maxSize) {
            this.flush.accept(String.join(" ", this));
            remove(0);
        }
        return r;
    }
}
